package net.sf.doolin.bus;

/**
 * Just a message with a parameter.
 * 
 * @author Damien Coraboeuf
 * @param <T>
 *            Message parameter type
 */
public class SimpleMessage<T> {

	private T parameter;

	/**
	 * Constructor with a parameter
	 * 
	 * @param parameter
	 *            Message parameter
	 */
	public SimpleMessage(T parameter) {
		this.parameter = parameter;
	}

	/**
	 * @return Message parameter
	 */
	public T getParameter() {
		return this.parameter;
	}

	@Override
	public String toString() {
		return String.valueOf(this.parameter);
	}

}
