package net.sf.doolin.bus;

/**
 * Execution definition for a subscriber.
 * 
 * @author Damien Coraboeuf
 * 
 * @param <M>
 *            Type of message the subscriber is handling.
 */
public interface SubscriberExecution<M> {

	/**
	 * Describes the execution. This information is used for debugging purpose
	 * only.
	 * 
	 * @return A description of the execution.
	 */
	String getExecutionDescription();

	/**
	 * This method called whenever a message is received.
	 * 
	 * @param message
	 *            Message to handle
	 */
	void receive(M message);

}
