package net.sf.doolin.bus;

/**
 * Trigger for a subscriber.
 * 
 * @author Damien Coraboeuf
 * 
 */
public interface SubscriberTrigger {

	/**
	 * Given any message, returns <code>true</code> if the subscriber can handle
	 * it.
	 * 
	 * @param message
	 *            Any received message
	 * @return <code>true</code> if the message can be handled.
	 */
	boolean accept(Object message);

	/**
	 * Description for the trigger
	 */
	String getTriggerDescription();

}
