package net.sf.doolin.bus.bean;

import net.sf.doolin.util.factory.DataFactory;
import net.sf.doolin.util.factory.IdentityDataFactory;

/**
 * Returns a {@link Bean} which is in buffered state.
 * 
 * @author Damien Coraboeuf
 * 
 * @param <B>
 *            Type of bean
 * @see Bean#bufferedNotification()
 */
public class BufferedBeanFactory<B extends Bean> implements DataFactory<B> {

	private DataFactory<B> dataFactory = new IdentityDataFactory<B>();

	@Override
	public B create(Object context) {
		B bean = this.dataFactory.create(context);
		bean.bufferedNotification();
		return bean;
	}

	/**
	 * @return the dataFactory
	 */
	public DataFactory<B> getDataFactory() {
		return this.dataFactory;
	}

	/**
	 * @param dataFactory
	 *            the dataFactory to set
	 */
	public void setDataFactory(DataFactory<B> dataFactory) {
		this.dataFactory = dataFactory;
	}

}
