package net.sf.doolin.bus.support;

import net.sf.doolin.bus.BusLog;
import net.sf.doolin.bus.Priority;
import net.sf.doolin.bus.Subscriber;

/**
 * Logs only the error messages.
 * 
 * @author Damien Coraboeuf
 * 
 */
public class DefaultBusLog implements BusLog {

	@Override
	public <M> void messageAccepted(M message, Subscriber<M> subscriber) {
	}

	@Override
	public void messageNoSubscription(Object message) {
	}

	@Override
	public void messageReceived(Object message) {
	}

	@Override
	public <M> void messageWithError(M message, Subscriber<M> subscriber,
			Throwable th) {
		System.err.format("Treatment of %s by %s has generated error %s%n",
				message, subscriber, th.getMessage());
		th.printStackTrace(System.err);
	}

	@Override
	public void registrationFailed(Subscriber<?> subscriber, Priority priority) {
	}

	@Override
	public void registrationOk(Subscriber<?> subscriber, Priority priority) {
	}

	@Override
	public void unregistration(Subscriber<?> subscriber) {
	}

}
