package net.sf.doolin.bus.support;

import java.util.concurrent.atomic.AtomicInteger;

import net.sf.doolin.bus.Priority;
import net.sf.doolin.bus.Subscriber;

/**
 * This {@link net.sf.doolin.bus.BusLog} counts the number of subscriptions in
 * the {@link net.sf.doolin.bus.Bus}.
 * 
 * @author Damien Coraboeuf
 * 
 */
public class SubscriptionCountBusLog extends DefaultBusLog {

	private final AtomicInteger count = new AtomicInteger(0);

	@Override
	public void registrationOk(Subscriber<?> subscriber, Priority priority) {
		int n = this.count.incrementAndGet();
		System.err.format("Subscription count is %d%n", n);
	}

	@Override
	public void unregistration(Subscriber<?> subscriber) {
		int n = this.count.decrementAndGet();
		System.err.format("Subscription count is %d%n", n);
	}

}
