package net.sf.doolin.bus.support;

/**
 * This {@link SubscriberValidator} can be controlled programmaticaly by
 * manually stopping it. Note that is is not possible to <i>restart</i> this
 * validator.
 * 
 * @author Damien Coraboeuf
 * 
 */
public class TriggeredSubscriberValidator implements SubscriberValidator {

	private boolean valid = true;

	@Override
	public String getValidatorDescription() {
		return "Triggered";
	}

	@Override
	public boolean isValid() {
		return this.valid;
	}

	/**
	 * Stops the validator. After this, any call to {@link #isValid()} will
	 * return <code>false</code>.
	 */
	public void stop() {
		this.valid = false;
	}

}
